<?php /*

  Hilfe zur Griffsuche
 
  Copyright (C) 2008 Maximilian Hoegner
 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


*/ ?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Griffsuche-Hilfe</title>
<!-- //////////////////////////////// STYLE //////////////////////////////// -->
<style type="text/css">
.bundnummern
{
	text-align: center;
	color: #AAA;
}

td.griffbrett,td.sattel
{
	background-color: #FDA;
	width: 3em;
	color: #000;
	text-align: center;
	padding: 0px;
}

td.tonleiter
{
	background-color: #D95;
}

td.sattel.gewaehlt div, td.griffbrett.gewaehlt div
{
	font-weight: bold;
	border: solid 3px #000;
}

td.sattel,td.sattel.gewaehlt
{
	border-right: solid .5em #000;
}
</style>
</head>
<body>

<?php

///////////////////////////// DEFINITIONEN /////////////////////////////////////

function mod($a,$b)
{
	return ($a%12+12)%12;
}

$tonleitern = array(
	"Dur"=>array(0,2,4,5,7,9,11),
	"Moll"=>array(0,2,3,5,7,8,10),
	"Ionisch"=>array(0,2,4,5,7,9,11),
	"Dorisch"=>array(0,2,3,5,7,9,10),
	"Phrygisch"=>array(0,1,3,5,7,8,10),
	"Lydisch"=>array(0,2,4,6,7,9,11),
	"Mixolydisch"=>array(0,2,4,5,7,9,10),
	"&Auml;olisch"=>array(0,2,3,5,7,8,10),
	"Lokrisch"=>array(0,1,3,5,6,8,10),
	"Spanisch-Phrygisch"=>array(0,1,4,5,7,8,10),
	"harmonisches Moll"=>array(0,2,3,5,7,8,11),
	"Zigeuner-Dur"=>array(0,1,4,5,7,8,11),
	"Zigeuner-Moll"=>array(0,2,3,6,7,8,11),
	"Dur-Pentatonik"=>array(0,2,4,7,9),
	"Moll-Pentatonik"=>array(0,3,5,7,10),
);

$toene = array('c','cis','d','dis','e','f','fis','g','gis','a','b','h');
//              0   1     2   3     4   5   6     7   8     9   10  11

?>
<?php

//////////////////////// INITIALISIERUNG ///////////////////////////////////////

$s = explode(',',$_REQUEST['saiten']);

$saitennum=array();
foreach($s as $value)
{
	if (($n=array_search(trim($value),$toene)) !==false)
	$saitennum[] = $n;
}

$_REQUEST['buende'] = (int)$_REQUEST['buende'];
$_REQUEST['grundton'] = (int)$_REQUEST['grundton'];

if (!isset($_REQUEST['button']))
{
	$_REQUEST['tonleiter']='Dur';
	$_REQUEST['ton']=array();
	$_REQUEST['buende'] = 12;
	$saitennum = array(4,11,7,2,9,4); // von E nach e
}

if ($_REQUEST['button'] != 'OK')
{
	$t =  $tonleitern[$_REQUEST['tonleiter']];
	$_REQUEST['ton']=array();

	// Prime
	if (in_array(0,$t)) $_REQUEST['ton'][0]=1;

	// Terz
	if (in_array(4,$t)) $_REQUEST['ton'][4]=1;
	else if (in_array(3,$t)) $_REQUEST['ton'][3]=1;
	else if (in_array(2,$t)) $_REQUEST['ton'][2]=1;

	// Quinte
	if (in_array(7,$t)) $_REQUEST['ton'][7]=1;
	else if (in_array(8,$t)) $_REQUEST['ton'][8]=1;
	else if (in_array(6,$t)) $_REQUEST['ton'][6]=1;
}

$ton2class = array();

for ($ton=0;$ton<12;$ton++)
{
	$class=array();

	if ($_REQUEST['ton'][mod($ton-$_REQUEST['grundton'],12)]) $class[]='gewaehlt';
	if (in_array(mod($ton-$_REQUEST['grundton'],12),$tonleitern[$_REQUEST['tonleiter']])) $class[]='tonleiter';
	$ton2class[$ton]=join(" ",$class);
}

$s = array();

foreach ($saitennum as $value)
	$s[] = $toene[$value];

$_REQUEST['saiten']=join(', ',$s);

?>
<!-- //////////////////////// FORMULAR ///////////////////////////////////// -->
<form action="<?php echo htmlentities($_SERVER['PHP_SELF']); ?>" method="post">
<select name="grundton">
<?php

foreach($toene as $nr=>$name) echo "<option value=\"$nr\"".((int)$_REQUEST['grundton']==$nr ? ' selected="selected"' : '').">$name</option>\n";

?>
</select>
<select name="tonleiter">
<?php

foreach($tonleitern as $name=>$l) echo "<option value=\"".htmlentities($name)."\"".($_REQUEST['tonleiter']==$name ? ' selected="selected"' : '').">".$name."</option>\n";

?>
</select><br>
<br>
Saiten: <input type="text" name="saiten" value="<?php echo $_REQUEST['saiten']; ?>">

B&uuml;nde: <input type="text" name="buende" value="<?php echo $_REQUEST['buende']; ?>">
<br><br>
<table>
<tr>
<?php
for ($ton=0;$ton<12;$ton++)
{
	$t = mod((int)$_REQUEST['grundton']+$ton,12);
	echo '<td class="'.$ton2class[$t].'">'.$toene[$t]."</td>\n";
}
?></tr><tr>
<td>1</td>
<td>9b</td>
<td>9</td>
<td>moll</td>
<td>dur</td>
<td>4</td>
<td>-</td>
<td>5</td>
<td>+</td>
<td>6</td>
<td>7</td>
<td>j7</td>
</tr><tr><?php
for ($ton=0;$ton<12;$ton++)
{
	echo '<td><input type="checkbox" name="ton['.$ton.']" value="1"'.($_REQUEST['ton'][$ton] ? ' checked="checked"':'')."></td>\n";
}
?></tr></table>
<input type="submit" name="button" value="OK">
<input type="submit" name="button" value="Dreiklang">
</form>
<br>
<br>
<!-- //////////////////////// GRIFFBRETT /////////////////////////////////// -->
<?php

echo '<table>';

echo '<tr class="bundnummern">';
echo '<td>&nbsp;</td>';
for ($bund=1;$bund<=$_REQUEST['buende'];$bund++)
	echo '<td>'.$bund."</td>\n";
echo '</tr>';

for ($saite=0;$saite<count($saitennum);$saite++)
{
	echo '<tr class="griffbrett">';
	$ton = mod($saitennum[$saite],12);
	echo '<td class="sattel '.$ton2class[$ton].'"><div>'.$toene[$ton]."</div></td>\n";

	for ($bund=1;$bund<=$_REQUEST['buende'];$bund++)
	{
		$ton=mod($saitennum[$saite]+$bund,12);
		echo '<td class="griffbrett '.$ton2class[$ton].'"><div>'.$toene[$ton]."</div></td>\n";
	}

	echo "</tr>\n";
}
echo '</table>';

?>

</body>
</html>
